#include <stdio.h>
#include <string.h>

typedef unsigned char uchar;

#define TRUE  1
#define FALSE 0

#define MAX_PORT_NUM 20 
#define MAX_STR_LEN 40

typedef enum
{
   SerialAdapter,
   ParallelAdapter,
   LastAdapter
}
AdapterType;

char AdapterName[LastAdapter][20] = { "Serial", "Parallel" };

void main(void)
{
   uchar i, j, sc, wv;
   uchar AdapterNum;
   char  PortNum;
   uchar EditConfig = TRUE;
   FILE  *FDes;
   char  rs[MAX_STR_LEN], SName[MAX_STR_LEN];

   FDes = fopen("/portcfg/pcf.cfg", "rb");            /* See if file exists */

   if (FDes == NULL)                      /* Create file if it didn't exist */
   {
      mkdir("/portcfg");                      /* Make directory off of root */
      FDes = fopen("/portcfg/pcf.cfg", "wb");         /* Create config file */
   }
   else
   {
      while (fread(&AdapterNum, 1, 1, FDes))           /* Read adapter type */
      {
         if (AdapterNum < (uchar) LastAdapter)/*Make sure valid adapter type*/
         {
            fread(&sc, 1, 1, FDes);                       /* Read seperator */
            fread(&PortNum, 1, 1, FDes);            /* Read number of ports */ 
            fread(&sc, 1, 1, FDes);                       /* Read seperator */

            printf("%s ports to be searched = %d\n", 
                   AdapterName[AdapterNum], 
                   PortNum);

            for (i = 0; i < (uchar) PortNum; i++) /* Loop through all ports */
            {
               j = 0;
               do                         /* Build string representing port */
               {
                  fread(&sc, 1, 1, FDes);
                  SName[j++] = sc;
               }
               while (sc != 0x7E);                    /* Look for seperator */
               SName[j - 1] = 0;                        /* Terminate string */              
               printf("%s port %d = %s\n",               /* Print port name */
                      AdapterName[AdapterNum], 
                      i + 1,
                      SName);
            }    
         }  
      }

      printf("Do you wish to alter the config file (y or n) ?\n");

      scanf("%s", rs);
      EditConfig = (strcmp(rs, "y") == 0);
    
      if (EditConfig)                 /* Blow away old file handle and file */
      {
         fclose(FDes);
         FDes = fopen("/portcfg/pcf.cfg", "wb");  /* Delete old config info */
      }
   }

   if (EditConfig && FDes)  
   {
      for (i = 0; i < (uchar) LastAdapter; i++)
      {
         wv = i;
         fwrite(&wv, 1, 1, FDes);                  /* Write out adapter type */
         fwrite("~", 1, 1, FDes);                              /* Seperator */

         PortNum = -1; 
         while (((uchar) PortNum < 0) || ((uchar) PortNum > MAX_PORT_NUM))
         {
            printf("Enter number %s ports to be searched for DS1412s\n",
                   AdapterName[i]);

            scanf("%d", &PortNum);      /* Get number of ports of this type */
         }
   
         fwrite(&PortNum, 1, 1, FDes);         /* Write out number of ports */
         fwrite("~", 1, 1, FDes);  
     
         if (PortNum)
         {
            j = 0;
            do
            {
               printf("Enter #%d %s port to be searched ",  
                      j + 1,
                      AdapterName[i]);

               printf("(i.e. /dev/ttyxx for COM%d or %d for LPT%d)\n", 
                      j + 1, j + 1, j + 1);

               scanf("%s", SName);                         /* Get port name */
   
               fwrite(SName, 1, strlen(SName), FDes);     /* Write out name */
               fwrite("~", 1, 1, FDes);  
            }
            while (++j < (uchar) PortNum);         /* Loop throug all ports */
         }
      }
   }

   if (FDes == NULL)                               /* Couldn't get a handle */
   {
      printf("Error opening configuration file\n");
      exit(1);
   }

   fclose(FDes);
}



