/*
    scratch.c
*/

#include "dbapi.h"

void handle_error(void)
{
   printf("No button found ...\n");
}

void main(int argc, char *argv[])
{
   unsigned int mi, mj, i;
   unsigned char *romptr, *curr_romptr, button_num;
   unsigned char scr_buff[65];
   unsigned int read_num = 1;                       /* Used to pound on key */

   if (argc > 1)
      read_num = atoi(argv[1]);

   romptr = take_census(&button_num);             /* Search for all buttons */

   printf("Back from take_census ...\n");

   if (!button_num)                                /* No buttons were found */
   {
      handle_error();
      exit(1);
   }

   if (button_num) 
   {
      printf("\nNumber of buttons found = %d\n\n", button_num);
   
      for (mi = 0; mi < button_num; mi++)  /* Print ROM data of all buttons */
      {
         for (mj = 0; mj < 8; mj++)
            printf("%2.2X ", *(romptr + (mi << 3) + mj));

         printf("\n");
      }

      curr_romptr = romptr;           /* curr_romptr points to 1st ROM byte */

      for (mj = 0; mj < button_num; mj++)      /* look at all buttons found */
      {
         if (*curr_romptr == 0x82)             /* see if button is a DS1425 */
         {
            for (i = 0; i < read_num; i++)
            {
               if (read_1425_sp(scr_buff, curr_romptr))  /* Read scratchpad */
               {
                  for (mi = 0; mi < 64; mi++)    /* display scratchpad data */
                     printf("%c", scr_buff[mi]);

                  printf("\n");
               }
               else
                  handle_error();      /* if failure, display error message */
            }
         }
         curr_romptr += 8;           /* point to family code of next button */
      }
   }
   else
      handle_error();
}



